package pps.core.base.service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import pps.core.base.entity.BasePowerLineDieselEnt;
import pps.core.base.entity.BasePowerLineDieselView;
import pps.core.base.mapper.BasePowerLineDieselMapper;
import pps.core.base.mapper.BasePowerLineDieselViewMapper;
import pps.core.base.service.data.base_power_line_diesel.*;
import xstartup.annotation.XService;
import xstartup.base.XContext;
import xstartup.base.data.CustomQueryInput;
import xstartup.base.util.XCopyUtils;
import xstartup.data.XPageResult;
import xstartup.data.XServiceResult;
import xstartup.data.XSingleResult;
import xstartup.error.XError;
import xstartup.feature.api.annotation.XApiAnonymous;
import xstartup.feature.api.annotation.XApiGet;
import xstartup.feature.api.annotation.XApiPost;
import xstartup.feature.mybatis.helper.XMapperHelper;

import java.util.List;

@XService
public class BasePowerLineDieselService {
    @XApiAnonymous
    @XApiPost
    public XServiceResult createBasePowerLineDiesel(XContext context, CreateBasePowerLineDieselInput input) {
        BasePowerLineDieselMapper mapper = context.getBean(BasePowerLineDieselMapper.class);
        BasePowerLineDieselEnt entity = new BasePowerLineDieselEnt();
        XCopyUtils.copyObject(input, entity);
        mapper.insert(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult updateBasePowerLineDiesel(XContext context, UpdateBasePowerLineDieselInput input) {
        BasePowerLineDieselMapper mapper = context.getBean(BasePowerLineDieselMapper.class);
        QueryWrapper<BasePowerLineDieselEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePowerLineDieselEnt::getId, input.getId());
        BasePowerLineDieselEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        XCopyUtils.copyObject(input, entity);
        mapper.updateById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiPost
    public XServiceResult deleteBasePowerLineDiesel(XContext context, DeleteBasePowerLineDieselInput input) {
        BasePowerLineDieselMapper mapper = context.getBean(BasePowerLineDieselMapper.class);
        QueryWrapper<BasePowerLineDieselEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePowerLineDieselEnt::getId, input.getId());
        BasePowerLineDieselEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XServiceResult.error(context, XError.NotFound);
        }
        mapper.deleteById(entity);
        return XServiceResult.OK;
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetBasePowerLineDieselOutput> getBasePowerLineDiesel(XContext context, GetBasePowerLineDieselInput input) {
        BasePowerLineDieselMapper mapper = context.getBean(BasePowerLineDieselMapper.class);
        QueryWrapper<BasePowerLineDieselEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().eq(BasePowerLineDieselEnt::getId, input.getId());
        BasePowerLineDieselEnt entity = mapper.selectOne(queryWrapper);
        if (entity == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBasePowerLineDieselOutput output = new GetBasePowerLineDieselOutput();
        XCopyUtils.copyObject(entity, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBasePowerLineDieselOutput> queryBasePowerLineDiesel(XContext context, QueryBasePowerLineDieselInput input) {
        BasePowerLineDieselMapper mapper = context.getBean(BasePowerLineDieselMapper.class);
        QueryWrapper<BasePowerLineDieselEnt> queryWrapper = new QueryWrapper<>();
        queryWrapper.lambda().like(BasePowerLineDieselEnt::getId, input.getId())
                .eq(BasePowerLineDieselEnt::getIsDeleted, input.getIsDeleted())
                .like(BasePowerLineDieselEnt::getCreateById, input.getCreateById())
                .like(BasePowerLineDieselEnt::getCreateByName, input.getCreateByName())
                .eq(BasePowerLineDieselEnt::getCreateTime, input.getCreateTime())
                .like(BasePowerLineDieselEnt::getModifyById, input.getModifyById())
                .like(BasePowerLineDieselEnt::getModifyByName, input.getModifyByName())
                .eq(BasePowerLineDieselEnt::getModifyTime, input.getModifyTime())
                .like(BasePowerLineDieselEnt::getLineId, input.getLineId())
                .like(BasePowerLineDieselEnt::getDieselId, input.getDieselId());
        return XMapperHelper.query(mapper, input, queryWrapper, QueryBasePowerLineDieselOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBasePowerLineDieselOutput> dynamicQueryBasePowerLineDiesel(XContext context, CustomQueryInput input) {
        BasePowerLineDieselMapper mapper = context.getBean(BasePowerLineDieselMapper.class);
        return XMapperHelper.query(mapper, input, BasePowerLineDieselEnt.class, QueryBasePowerLineDieselOutput.class);
    }

    @XApiAnonymous
    @XApiGet
    public XSingleResult<GetBasePowerLineDieselViewOutput> getBasePowerLineDieselView(XContext context, GetBasePowerLineDieselViewInput input) {
        BasePowerLineDieselViewMapper mapper = context.getBean(BasePowerLineDieselViewMapper.class);
        BasePowerLineDieselView record = new BasePowerLineDieselView();
        XCopyUtils.copyObject(input, record);
        BasePowerLineDieselView view = mapper.selectOne(record);
        if (view == null) {
            return XSingleResult.error(context, XError.NotFound);
        }
        GetBasePowerLineDieselViewOutput output = new GetBasePowerLineDieselViewOutput();
        XCopyUtils.copyObject(view, output);
        return XSingleResult.success(output);
    }

    @XApiAnonymous
    @XApiGet
    public XPageResult<QueryBasePowerLineDieselViewOutput> queryBasePowerLineDieselView(XContext context, QueryBasePowerLineDieselViewInput input) {
        BasePowerLineDieselViewMapper mapper = context.getBean(BasePowerLineDieselViewMapper.class);
        BasePowerLineDieselView record = new BasePowerLineDieselView();
        XCopyUtils.copyObject(input, record);
        PageHelper.startPage(input.getPage(), input.getLimit());
        List<BasePowerLineDieselView> list = mapper.selectList(record);
        PageInfo<BasePowerLineDieselView> pageInfo = new PageInfo<>(list);
        List<QueryBasePowerLineDieselViewOutput> outputs = XCopyUtils.copyNewList(pageInfo.getList(), QueryBasePowerLineDieselViewOutput.class);
        return XPageResult.success(outputs, input, pageInfo.getTotal());
    }

}
